#ifndef COMMS_H
#define COMMS_H 1

void   flim_comms_do_gui(int val);
void  *flim_comms_connect_nexxus(char *address, char *login, char *password);
void   flim_comms_disconnect_nexxus(void *handle);
void   flim_comms_send_msg(void *handle, char *message);
char **flim_comms_get_reply(void *handle, int *ret_count);
void   flim_comms_free_reply(char **reply, int count);

#define FLIM_COMMS_REPLY __reply
#define FLIM_COMMS_REPLY_COUNT __reply_count
#define FILM_COMMS_REPLY_START \
{char **__reply = NULL; int __reply_count = 0; void *__handle = NULL;
#define FLIM_COMMS_SET_HANDLE(handle) \
__handle = handle;
#define FILM_COMMS_REQUEST(message) \
flim_comms_send_msg(__handle, message); \
__reply = flim_comms_get_reply(__handle, &__reply_count); \
if (__reply) { \
  if ((!strcmp(FLIM_COMMS_REPLY[0], "MODULE_NOT_FOUND")) || \
      ((__reply_count >= 3) && \
       (!strcmp(FLIM_COMMS_REPLY[2], "MODULE_NOT_FOUND")))) { \
    flim_comms_free_reply(__reply, __reply_count); \
    __reply_count = -1; \
  } \
  else \
    flim_comms_free_reply(__reply, __reply_count); \
  __reply = NULL; \
}
#define FILM_COMMS_GET_REPLY \
if (__reply) {flim_comms_free_reply(__reply, __reply_count); __reply = NULL;} \
__reply = flim_comms_get_reply(__handle, &__reply_count);
#define FILM_COMMS_REPLY_END \
if (__reply) {flim_comms_free_reply(__reply, __reply_count); __reply = NULL;}}
#define FLIM_COMMS_BEGIN(handle, message) \
FILM_COMMS_REPLY_START; \
FLIM_COMMS_SET_HANDLE(handle); \
FILM_COMMS_REQUEST(message); \
if (FLIM_COMMS_REPLY_COUNT != -1) {\
FILM_COMMS_GET_REPLY;}

#endif
