#ifndef GROUP_H
#define GROUP_H 1

typedef struct _group Group;

struct _group
{
   char  *name;
   GList *members;
   
   int   selected;
};

void flim_group_load(void);
void flim_group_save(void);
Group *flim_group_new(void);
Group *flim_group_find(char *name);
void flim_group_add_member(Group *g, void *member);
void flim_group_del_member(Group *g, void *member);
void flim_group_free(Group *g);
void flim_group_purge_member(void *member);
void flim_group_select(GtkWidget *tree);
void flim_group_build_list(GtkWidget *list);

#endif
